program Nibbles;
uses time,prompt2,dos,crt;

{

    Copyright (C) 1994 Matthias S. Benkmann <m.s.b@gmx.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License,
    NOT any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



if you enter JOLLY ROGER as name then you get 99 lives and by pressing
J while playing you can skip a level}

{$M 4096,0,1}

{STRUCTURE OF CAMPAIGN .CPN FILES:

ATTENTION!!!!!! DON'T FORGET THERE'S A CAMPMINSIZE CONSTANT !!!!!
                IT IS ALSO REFERRED TO 24 AS THE CAMPHEADER SIZE AT VARIOUS
                POINTS

offset     size       meaning
  0        21         id string: 'NIBBLES CAMPAIGN FILE'
  21       1          number of levels in campaign
  22       1                     lives of player 1
  23       1                     lives of player 2
  24       1          task byte: 0 means numbers 1 to 0 have to be collected
                                 once, numbers appear one at a time in
                                 ascending value
                                 1 means random numbers from 1 to 9 have to
                                 be collected, byte 25 says how many
                                 snake fading is on in this mode
                                 2 means the numbers are preset on the
                                 playfield and no numbers are added after one
                                 is taken, the number of numbers that are
                                 preset must be in byte 25

  25       1                     if 24 is 1 then this is number of numbers
                                 to be collected

  
  26       1                     start x of player 1 (c.f.0)
  27       1                     start y of player 1 (starting with 1)
  28       1                     start growth of player 1
  29       1                     start direction of player 1

  
  30       1                     start x of player 2 (c.f.0)
  31       1                     start y of player 2 (starting with 1)
  32       1                     start growth of player 2
  33       1                     start direction of player 2


  34       1                     foreground color (must not be same as player
                                                   or death color)
  35       1                     background color (must not be same as player
                                                   or death color)
  36       1                     player 1 color
  37       1                     player 2 color
  38       1                     death color
  39       1                     number color

  40       80*24                 character map of level
  1960     80*24 bits            bit field whether number may appear at
                                 position (bit is 1) or not (bit is 0)
  2200     same as 24-2199 for 2nd level
    .
    .
    .
}

type
  campheader=record
               id:array[0..20] of char;
               levelnum:byte;
               lives1,lives2:byte;
             end;

  segment=record
            x:byte;
            y:byte;
            pos:byte;  {1 means top, 0 means bottom}
          end;
  movestate=(alive,dead,number);
  snake=record
          direction:(UP,DOWN,LEFT,RIGHT);
          tail:array[0..255] of segment;
          len:byte;
          growth:byte; {<>0 means this number of segments has to grow still}
          unplotflag:boolean;
          doubleunplotflag:boolean;
          fadecount:byte;
          col:byte;
          state:movestate;
          state2:movestate;
          lives:byte;
          name:string[11];
          points:longint;
        end;
  leveltype=record
          task:byte;
          numnum:byte;
          startx1:byte;
          starty1:byte;
          startgrowth1:byte;
          dir1:byte;
          startx2:byte;
          starty2:byte;
          startgrowth2:byte;
          dir2:byte;
          forecolor:byte;
          backcolor:byte;
          p1color:byte;
          p2color:byte;
          deathcol:byte;
          numcolor:byte;
          field:array[0..79,0..23] of char;
          allow:array[0..239] of byte;
        end;
  namstr=string[12];
  overlayer=array[0..65000] of byte;
  pleveltype=^leveltype;
  notetype=record
             value:byte;
             octave:byte;
             len:byte;
           end;

const
  vidmode:byte=2;
  campminsize=2200; {size of a 1 level campaign}
  deathfadestart=1;
  taskfadestart=7;
  ptpercent=10;
  lifepercent=2;
  nibtheme1='c5d5e5d5c5d5';
  nibtheme2='e5c5c5 ';
  nibtheme3='c4d4e4d4c4d4';
  nibtheme4='e4c4c4 ';
  victory1='c6 c6c6';
  victory2='g6 ';
  victory3='c7d7e7f7 ';
  victory4='c6d6e6f6 ';
  numtune='c4c4c4e4 ';
  bonus1='c6c7 ';
  bonus2='c7c6 ';
  deathtune='e2f2g2e2f2d2c2 ';
  playtab:array[1..7,2..8] of word=((36489,18244,9122,4561,2281,1140,570),
                                    (32512,16256,8128,4064,2032,1016,508),
                                    (28961,14480,7240,3620,1810, 905,453),
                                    (27367,13683,6842,3421,1710, 855,428),
                                    (24351,12175,6088,3044,1522, 761,380),
                                    (21694,10847,5424,2712,1356, 678,339),
                                    (19338, 9669,4835,2417,1209, 604,302));


var
   playfield:array[0..24,0..79,0..1] of char absolute $b800:0;
   player:array[1..2] of snake;
   slowie,slowiecount:word;
   count21:word;
   milicount:word;
   skill:byte;
   oldfore,oldback:byte;
   a,b,x,y:byte;
   c,ch:char;
   oldexit:pointer;
   incspeed,play2:boolean;
   level:pleveltype;
   campaign:^campheader;
   camsize:longint;
   campfile:file;
   dir:array[1..100] of string[12];
   fil:array[1..400] of string[12];
   dirnum,fnum:word;
   s:searchrec;
   displaystart:word;
   st:string;
   campname:string[12];
   current:byte;
   confirmbuf:array[0..3*160] of byte;
   maxlevels:byte;
   vic:boolean;
   titletime:longint;
   titlestart:byte;
   numstoget:byte;
   curlevel:byte;
   restart:boolean;
   restarttype:byte;
   buffer1:array[0..20] of char;
   head1:byte;
   tail1:byte;
   buffer2:array[0..20] of char;
   head2:byte;
   tail2:byte;
   quitflag:boolean;
   notebuf:array[0..20] of notetype;
   notehead:byte;
   notetail:byte;
   notecount:byte;
   bonusflag:byte;
   starttuneflag:boolean;

label anfang,playstart,playstart2,playstart3,afterpause,next1;


PROCEDURE CENTERWRITE(ST:STRING;MAXX:BYTE);
var
  x:byte;
begin
  x:=length(st);
  if x>=maxx then gotoxy(1,wherey) else
  begin
    if odd(maxx) then inc(maxx) else if odd(x)=false then dec(x);
    gotoxy(maxx div 2-x div 2,wherey);
  end;
  write(st);
end;

PROCEDURE CENTERWRITELN(ST:STRING;MAXX:BYTE);
begin
  centerwrite(st,maxx);
  write(#13,#10);
end;

FUNCTION STRX(L:LONGINT):STRING;
var s:string;
begin
  str(l,s);
  strx:=s;
end;

PROCEDURE COLOR(FOREGROUND,BACKGROUND:BYTE);
begin
  textattr:=0;
  textcolor(foreground);
  inc(textattr,background shl 4);
end;

PROCEDURE SETCURSOR(START,STOP:BYTE);
var
  reg:registers;
begin
  reg.ah:=1;
  reg.ch:=start;
  reg.cl:=stop;
  intr($10,reg);
end;

PROCEDURE DELCHARS(VAR ST:STRING;CH:CHAR);
begin
  while(pos(ch,st))>0 do delete(st,pos(ch,st),1);
end;

FUNCTION SPLITADDR(L:LONGINT):POINTER;
begin
  splitaddr:=ptr(l div 16,l mod 16);
end;


FUNCTION ADDRESS(P:POINTER):LONGINT;
var
  a:longint;
begin
  a:=seg(p^);
  address:=a shl 4+ofs(p^);;
end;

FUNCTION UPCASESTR(S:STRING):STRING;
var
  laufvar:byte;
begin
  for laufvar:=1 to length(s) do
  if (s[laufvar] >='a') and (s[laufvar] <='z') then
  Dec(S[laufvar], 32)
  else if s[laufvar]='' then s[laufvar]:=''
  else if s[laufvar]='' then s[laufvar]:=''
  else if s[laufvar]='' then s[laufvar]:='';
  upcasestr:=S;
end;


FUNCTION EXIST(S:STRING):BOOLEAN;
var
  f:file;
  a:byte;
begin
  a:=filemode;
  filemode:=0;
  assign(f,s);
  {$i-}
  reset(f,1);
  filemode:=a;
  exist:=ioresult=0;
  close(f);
  a:=ioresult; {dummy read to clear error state}
  {$i+}
end;


FUNCTION DOSMEMAVAIL:WORD;ASSEMBLER;
asm
  mov ah,48h
  mov bx,0ffffh
  int 21h
  jnc @allfree
  mov ax,bx
  jmp @ende
@allfree:
  mov es,ax
  mov ah,49h
  int 21h
  mov ax,0ffffh
@ende:
end;


PROCEDURE GETDOSMEM(VAR P:POINTER;SIZE:LONGINT);assembler;
asm
  db 66h
  mov ax,word ptr size
  db 66h
  db 05h     {add eax,15}
  dd 15
  db 66h
  shr ax,4
  mov bx,ax
  mov ah,48h
  int 21h
  jc @error
@send:
  les di,[p]
  mov bx,ax
  sub ax,ax
  stosw
  mov ax,bx
  stosw
  jmp @ende

@error:
  sub ax,ax
  jmp @send

@ende:
end;

PROCEDURE FREEDOSMEM(VAR P:POINTER);
begin
asm
  mov ah,49h
  les di,p
  mov es,es:[di+2]
  int 21h
end;
  p:=nil;
end;

PROCEDURE BLINKBIT(B:BOOLEAN);
var
  reg:registers;

begin
  reg.ah:=$10;
  reg.al:=3;
  case b of
    true:reg.bl:=1;
    false:reg.bl:=0;
  end;
  intr($10,reg);
end;


procedure playnote(n,o:byte);
var
  w:word;
begin
  if n<>0 then
  begin
    w:=playtab[n,o];
    asm
      mov al,10110110b
      out 43h,al
      mov ax,w
      out 42h,al
      mov al,ah
      out 42h,al
      in al,61h
      or al,11b
      out 61h,al
    end;
  end else
  asm
    in al,61h
    and al,not 3
    out 61h,al
  end;
end;

procedure haltx;far;
begin
   exitproc:=oldexit;
   playnote(0,0);
   asm
     mov ax,1202h
     mov bl,30h
     int 10h
     mov ax,3
     int 10h
   end;
end;

procedure play(st:string;l:byte);
var
  a,b:byte;
begin
  for a:=1 to length(st) do
  begin
    if ((notehead=0) and (notetail<>20)) or ((notehead>0) and (notehead-notetail<>1)) then
    begin
      b:=byte(st[a]);
      if b=32 then
      begin
        notebuf[notetail].len:=l;
        notebuf[notetail].value:=0;
        notebuf[notetail].octave:=0;
      end else
      if a+1<=length(st) then
      begin
        case upcase(char(b)) of
          'C': notebuf[notetail].value:=1;
          'D': notebuf[notetail].value:=2;
          'E': notebuf[notetail].value:=3;
          'F': notebuf[notetail].value:=4;
          'G': notebuf[notetail].value:=5;
          'A': notebuf[notetail].value:=6;
          'H': notebuf[notetail].value:=7;
        end;
        inc(a);
        notebuf[notetail].octave:=byte(st[a])-48;
        notebuf[notetail].len:=l;
      end;
      inc(notetail);
      if notetail=21 then notetail:=0;
    end;
  end;
end;



procedure plot(x,y,pos,col:byte);
var
  temp,temp2:byte;
begin
  temp:=byte(playfield[y,x,0]);
  temp2:=byte(playfield[y,x,1]) and 15;
  if (temp2=col) or (temp=32) then
  begin
    if temp=219 then exit;
    if temp=220 then if pos=0 then exit else temp:=219 else
    if temp=223 then if pos=1 then exit else temp:=219 else
    if pos=0 then temp:=220 else temp:=223;
    playfield[y,x,0]:=char(temp);
    byte(playfield[y,x,1]):=byte(playfield[y,x,1]) and $f0+col;
  end else
  byte(playfield[y,x,1]):=(byte(playfield[y,x,1]) and 15)+col shl 4;
end;

procedure unplot(x,y,pos,col:byte);
var
  temp,temp2:byte;
begin
  if vic then exit;
  temp:=byte(playfield[y,x,0]);
  temp2:=(byte(playfield[y,x,1]) and $f0);
  if temp2=level^.backcolor shl 4 then
  begin
    if pos=0 then
    begin
      if (temp=223) or (temp=32) then exit;
      if temp=219 then temp:=223 else temp:=32;
    end else
    begin
      if (temp=220) or (temp=32) then exit;
      if temp=219 then temp:=220 else temp:=32;
    end;
    playfield[y,x,0]:=char(temp);
    if temp=32 then byte(playfield[y,x,1]):=level^.backcolor shl 4+level^.forecolor;
  end else
  begin
    if temp2=col shl 4
    then byte(playfield[y,x,1]):=(byte(playfield[y,x,1]) and 15)+level^.backcolor shl 4
    else
    begin
      byte(playfield[y,x,1]):=temp2 shr 4+level^.backcolor shl 4;
      if temp=220 then playfield[y,x,0]:=#223 else playfield[y,x,0]:=#220;
    end;
  end;
end;

procedure headline;
begin
  gotoxy(1,1);
  if play2 then
     write(player[2].name,' lives: ',player[2].lives:2,' score: ',player[2].points);
  centerwrite('Level: '+strx(curlevel),76);
  gotoxy(44,1);
  writeln(player[1].name,' lives: ',player[1].lives:2,' score: ',player[1].points);
end;

procedure death(var pl:snake);
begin
  if vic then exit;
  with pl do
  begin;
  unplot(tail[0].x,tail[0].y,tail[0].pos,col);
  plot(tail[0].x,tail[0].y,tail[0].pos,level^.deathcol);
  fadecount:=deathfadestart;
  unplotflag:=false;
  doubleunplotflag:=true;
  dec(lives);
  state:=alive;
  state2:=dead;
  notehead:=0;
  notetail:=0;
  play(deathtune,6);
  notehead:=20;
  headline;
  end;
end;



procedure startup;
var
  a,b:byte;
begin
  with level^ do
  begin
  color(forecolor,backcolor);
  clrscr;
  for b:=0 to 23 do
  for a:=0 to 79 do
  begin
    playfield[b+1,a,0]:=field[a,b];
    if field[a,b] in [#156,#158,'0','1','2','3','4','5','6','7','8','9'] then
    playfield[b+1,a,1]:=char(level^.numcolor+level^.backcolor shl 4);
  end;

  with player[1] do
  begin
    len:=1;
    if task=1 then fadecount:=taskfadestart;
    tail[0].x:=startx1;
    tail[0].y:=starty1;
    tail[0].pos:=0;
    growth:=startgrowth1;
    byte(direction):=dir1;
    col:=p1color;
    state:=alive;
    state2:=alive;
    unplotflag:=false;
    doubleunplotflag:=false;
    if lives<>0 then plot(tail[0].x,tail[0].y,tail[0].pos,col);
  end;

  with player[2] do
  begin
    if task=1 then fadecount:=taskfadestart;
    len:=1;
    tail[0].x:=startx2;
    tail[0].y:=starty2;
    tail[0].pos:=0;
    growth:=startgrowth2;
    byte(direction):=dir2;
    col:=p2color;
    state:=alive;
    if not play2 then state2:=dead else state2:=alive;
    unplotflag:=false;
    doubleunplotflag:=false;
    if play2 then plot(tail[0].x,tail[0].y,tail[0].pos,col);
  end;

  headline;

  if task=0 then numstoget:=11 else numstoget:=numnum+1;

  delay(200);
  while keypressed do readkey;
  repeat until keypressed;
  end;
end;

function blocked(x,y,pos:byte):boolean;
var temp2:byte;
begin
  if (player[1].tail[0].x=x) and (player[1].tail[0].y=y) and (player[1].tail[0].pos=pos)
     and (player[1].state2=alive) then
  begin
    blocked:=true;
    exit;
  end;

  if (player[2].tail[0].x=x) and (player[2].tail[0].y=y) and (player[2].tail[0].pos=pos)
     and (player[2].state2=alive) then
  begin
    blocked:=true;
    exit;
  end;

  temp2:=byte(playfield[y,x,1]) shr 4;
  if playfield[y,x,0] in [' ','1','2','3','4','5','6','7','8','9','0','',''] then
  begin
    blocked:=false;
    exit;
  end;
  if playfield[y,x,0] in [''] then
  begin
    if (pos=0) or (temp2<>level^.backcolor) then blocked:=true else blocked:=false;
    exit;
  end;
  if playfield[y,x,0] in [''] then
  begin
    if (pos=1) or (temp2<>level^.backcolor) then blocked:=true else blocked:=false;
    exit;
  end else blocked:=true;
end;


function movesnake(var s:snake):movestate; {returns alive if the move has not
                                        caused the snake to die
                                        and dead if it has, in latter case
                                        the variable s is not changed}
var
  temp:segment;
begin
with s do
begin
  temp:=tail[0];
  case direction of
    up:   begin
            temp.pos:=temp.pos xor 1;
            if temp.pos=0 then dec(temp.y);
            if temp.y=0 then temp.y:=24;
          end;
   down:  begin
            temp.pos:=temp.pos xor 1;
            if temp.pos=1 then inc(temp.y);
            if temp.y=25 then temp.y:=1;
          end;
   left:  begin
            dec(temp.x);
            if temp.x=255 then temp.x:=79;
          end;
   right: begin
            inc(temp.x);
            if temp.x=80 then temp.x:=0;
          end;
  end;
  if blocked(temp.x,temp.y,temp.pos) then
  begin
    movesnake:=dead;
    exit;
  end;
  move(tail[0],tail[1],len*sizeof(segment));
  tail[0]:=temp;
  unplotflag:=false;
  doubleunplotflag:=false;
  if growth<>0 then
  begin
    if len+1<250 then inc(len) else growth:=1;
    dec(growth);
  end else
  begin
    unplotflag:=true;
    if level^.task=1 then
    begin
      dec(fadecount);
      if fadecount=0 then
      begin
        fadecount:=taskfadestart;
        if len=1 then
        begin
          move(tail[1],tail[0],len*sizeof(segment));
          unplotflag:=false;
          movesnake:=dead;
          exit;
        end;
        doubleunplotflag:=true;
      end;
    end;
  end;
  if playfield[temp.y,temp.x,0] in ['1','2','3','4','5','6','7','8','9','0','',''] then
     movesnake:=number else movesnake:=alive;
end;
end;

procedure grow(var s:snake);
var
  l:longint;
  a:byte;
begin
with s do begin
  a:=byte(playfield[tail[0].y,tail[0].x,0]);
  if a=158 then
  begin
    l:=points div 50000;
    points:=points+2000;
    if points div 50000>l then inc(lives);
    state:=alive;
    bonusflag:=1;
  end else if a=156 then
  begin
    inc(lives);
    bonusflag:=2;
    state:=alive;
  end else
  begin
    if char(a)='0' then if curlevel+1<=campaign^.levelnum then a:=68 else a:=78;
    if len+growth+2*(a-48)<250 then growth:=growth+2*(a-48) else growth:=249-len;
    l:=points div 50000;
    points:=points+(a-48)*100;
    if points div 50000>l then inc(lives);
  end;
  headline;
  playfield[tail[0].y,tail[0].x,0]:=' ';
  if not vic then playfield[tail[0].y,tail[0].x,1]:=char(level^.forecolor+level^.backcolor shl 4)
             else playfield[tail[0].y,tail[0].x,1]:=char(oldfore+oldback shl 4);
end;
end;

procedure writeup;
begin
  mem[$b800:21*160+2*46]:=24;
end;

procedure writedown;
begin
  mem[$b800:21*160+2*46]:=25;
end;

procedure writeupdown;
begin
  mem[$b800:21*160+2*46]:=18;
end;

procedure writecorner;
begin
  mem[$b800:21*160+2*46]:=188;
end;

function stringgreater(s1,s2:namstr):boolean;
var
  a,l:byte;
begin
  l:=length(s1);
  if l>length(s2) then l:=length(s2);
  a:=0;
  repeat
    inc(a);
  until (a>l) or (s1[a]<>s2[a]);
  if (a<=l) and (byte(s1[a])>byte(s2[a])) then stringgreater:=true
     else stringgreater:=false;
end;

procedure swapstrings(var st1,st2:namstr);
var
  temp:namstr;
begin
  temp:=st1;
  st1:=st2;
  st2:=temp;
end;

function lowcase(c:char):char;
begin
  if (c<='Z') and (c>='A') then byte(c):=byte(c)+32 else
  if c='' then c:='' else
  if c='' then c:='' else
  if c='' then c:='';
  lowcase:=c;
end;

function lowcasestr(s:namstr):string;
var a:byte;
begin
  for a:=1 to length(s) do s[a]:=lowcase(s[a]);
  lowcasestr:=s;
end;

procedure displaydir(path:string);
var a,b:word;
begin
  findfirst('*.*',directory,s);
  dirnum:=0;
  if doserror=0 then
  begin
    a:=1;
    repeat
      s.attr:=0;
      findnext(s);
      if s.attr=directory then
      begin
        dir[a]:=s.name;
        inc(a);
      end;
    until (doserror<>0) or (a=101);
    dirnum:=a-1;
  end;
  findfirst(path,archive,s);
  fnum:=0;
  if doserror=0 then
  begin
    fil[1]:=s.name;
    a:=2;
    repeat
      findnext(s);
      if doserror=0 then
      begin
        fil[a]:=s.name;
        inc(a);
      end;
    until (doserror<>0) or (a=401);
    fnum:=a-1;
  end;
  if dirnum>1 then
  begin
    for a:=1 to dirnum-1 do
    for b:=a to dirnum do
    if stringgreater(dir[a],dir[b]) then swapstrings(dir[a],dir[b]);
  end;
  if fnum>1 then
  begin
    for a:=1 to fnum-1 do
    for b:=a to fnum do
    if stringgreater(fil[a],fil[b]) then swapstrings(fil[a],fil[b]);
  end;
  for a:=1 to fnum do fil[a]:=lowcasestr(fil[a]);
  a:=1;
  if dirnum>0 then
  begin
    repeat
      gotoxy(3,a+3);
      write(dir[a]);
      inc(a);
    until (a>dirnum) or (a=18);
    if a<=dirnum then writedown;
  end;
  if (fnum>0) and (a<>18) then
  begin
    b:=1;
    repeat
      gotoxy(3,a+3);
      write(fil[b]);
      inc(a);
      inc(b);
    until (b>fnum) or (a=18);
    if b<=fnum then writedown;
  end;
end;

procedure highlight(curpos:byte;state:boolean);
var
  a:word;
  vram:array[0..10000] of byte absolute $b800:0;
begin
  for a:=0 to 14 do
  if state=true then vram[curpos*160+a*2+31*2+1]:=yellow+green shl 4 else
                     vram[curpos*160+a*2+31*2+1]:=yellow+blue shl 4;
end;

procedure displaydir2;
var
  a:byte;
  b:word;
begin
  a:=4;
  b:=displaystart;
  if b<=dirnum then
  begin
    repeat
      gotoxy(3,a);
      write(dir[b],'':14-length(dir[b]));
      inc(a);
      inc(b);
    until (b>dirnum) or (a=21);
    if b<=dirnum then if displaystart>1 then writeupdown else writedown else
    if displaystart>1 then writeup else writecorner;
  end;
  b:=b-dirnum;
  if (fnum>0) and (a<>21) then
  begin
    repeat
      gotoxy(3,a);
      write(fil[b],'':14-length(fil[b]));
      inc(a);
      inc(b);
    until (b>fnum) or (a=21);
    if b<=fnum then if displaystart>1 then writeupdown else writedown else
    if displaystart>1 then writeup else writecorner;
  end;
end;

procedure emptylevel;
begin
  level^.task:=0;
  level^.numnum:=0;
  level^.startx1:=50;
  level^.starty1:=10;
  level^.startgrowth1:=2;
  level^.dir1:=3;
  level^.startx2:=33;
  level^.starty2:=10;
  level^.startgrowth2:=2;
  level^.dir2:=2;
  level^.forecolor:=lightgreen;
  level^.backcolor:=blue;
  level^.p1color:=yellow;
  level^.p2color:=lightmagenta;
  level^.deathcol:=lightred;
  level^.numcolor:=yellow;
  fillchar(level^.field,sizeof(level^.field),' ');
  fillchar(level^.allow,sizeof(level^.allow),255);
end;
procedure makeemptycampaign;
begin
  st:='NIBBLES CAMPAIGN FILE';
  move(st[1],campaign^.id,21);
  campaign^.levelnum:=1;
  campaign^.lives1:=3;
  campaign^.lives2:=3;
  emptylevel;
end;

function choose(path:string;func:byte):namstr;
var
  a:word;
  direct:boolean;
  lname:string[12];
  c:char;
  lptr:byte;
  ins:boolean;
  curpos:word;
label otto,anfang;
begin
  ins:=true;
  if func=0 then direct:=true else direct:=false;
  lname:='';
  lptr:=1;
anfang:
  window(31,2,47,22);
  color(yellow,blue);
  clrscr;
  if func=0 then
  begin
    write                  (' EDIT CAMPAIGN ');
    write                  ('               ');
    write                  ('͹');
  end else
  begin
    write                  ('ͻ');
    write                  (' LOAD CAMPAIGN ');
    write                  ('͹');
  end;
  for a:=1 to 17 do write  ('               ');
  write                    ('');
  writecorner;
  displaydir(path);
  displaystart:=1;
  curpos:=4;
  repeat
    if direct=true then
    begin
      if ins then setcursor(6,7) else setcursor(0,16);
      gotoxy(3,2);
      write(lname,'':12-length(lname));
      gotoxy(2+lptr,2);
      c:=readkey;
      if c>=#32 then
      begin
        if ins=false then
        begin
          lname[lptr]:=c;
          if (lptr>length(lname)) then inc(byte(lname[0]));
          if lptr<12 then inc(lptr);
        end else
        begin
          for a:=12 downto lptr+1 do lname[a]:=lname[a-1];
          lname[lptr]:=c;
          if lptr<12 then inc(lptr);
          if length(lname)<12 then inc(lname[0]);
        end;
      end else
      if (c=#0) then
      begin
        c:=readkey;
otto:
        case byte(c) of
          $4b: if lptr>1 then dec(lptr);
          $4d: if (lptr<12) and (lptr<=length(lname)) then inc(lptr);
          $52: ins:=ins xor true;
          $53: if lptr<=length(lname) then
               begin
                 for a:=lptr to 11 do lname[a]:=lname[a+1];
                 if length(lname)>0 then dec(byte(lname[0]));
               end;
        end;
      end else
      if c=#8 then
      if lptr>1 then
      begin
        dec(lptr);
        byte(c):=$53;
        goto otto;
      end else else
      if c=#9 then if (fnum>0) or (dirnum>0) then direct:=false;
    end else
    begin
      setcursor(16,0);
      highlight(curpos,true);
      c:=readkey;
      if c=#0 then
      begin
        c:=readkey;
        case byte(c) of
          $48: if (curpos>4) then
               begin
                 highlight(curpos,false);
                 dec(curpos);
               end else
               if displaystart>1 then
               begin
                 dec(displaystart);
                 displaydir2;
               end;
          $50: if (curpos<20) and (curpos-3<fnum+dirnum) then
               begin
                 highlight(curpos,false);
                 inc(curpos);
               end else
               if displaystart+curpos-4<fnum+dirnum then
               begin
                 inc(displaystart);
                 displaydir2;
               end;
        end;
      end else
      if (c=#9) and (func=0) then
      begin
        highlight(curpos,false);
        direct:=true;
      end;
    end;
  until (c=#27) or (c=#13);
  if c=#27 then choose:='...' else
  if direct=true then
  begin
    delchars(lname,' ');
    if pos('.',lname)<>0 then lname:=copy(lname,1,pos('.',lname)-1);
    choose:=lname;
  end else
  begin
    if displaystart+curpos-4<=dirnum then
    begin
      {$i-}
      chdir(dir[displaystart+curpos-4]);
      {$i+}
      a:=ioresult;
      goto anfang;
    end else
    begin
      if pos('.',fil[displaystart+curpos-4-dirnum])<>0
         then fil[displaystart+curpos-4-dirnum]:=
         copy(fil[displaystart+curpos-4-dirnum],1,pos('.',fil[displaystart+curpos-4-dirnum])-1);
      choose:=fil[displaystart+curpos-4-dirnum];
    end;
  end;
  window(1,1,80,25);
  color(lightgray,black);
end;

function confirm(mess:string):boolean;
var
  vram:array[0..10000] of byte absolute $b800:0;
  a,b,c:word;
  d:char;
begin
  move(vram[10*160],confirmbuf,3*160);
  mess:=' '+mess+' ';
  c:=(80-length(mess)) shr 1;
  setcursor(16,0);
  
  gotoxy(1,12);
  centerwriteln(mess,80);
  gotoxy(c+1,11);
  write('');
  for a:=1 to length(mess)-2 do write('');
  write('');
  gotoxy(c+1,13);
  write('');
  for a:=1 to length(mess)-2 do write('');
  write('');
  for b:=10 to 12 do
  for a:=c to c+length(mess)-1 do
  vram[b*160+2*a+1]:=black+red shl 4;
  repeat
    d:=upcase(readkey);
  until d in ['Y','N'];
  move(confirmbuf,vram[10*160],3*160);
  confirm:=  (d='Y');
end;

procedure saveerr;
begin
  gotoxy(1,7);
  color(black,red);
  writeln('COULD NOT SAVE FILE! TRY REMOVING LEVELS!');
  color(lightgray,black);
  delay(2000);
end;

procedure selectlevel(var level:pleveltype;num:byte);
begin
  pointer(level):=splitaddr(address(campaign)+24+(num-1)*(campminsize-24));
end;

procedure movelevel(n1,n2:byte);
var
  source,dest:pleveltype;
begin
  selectlevel(dest,n2);
  selectlevel(source,n1);
  move(source^,dest^,campminsize-24);
end;

procedure levelmanager;
var
  oldname:string[12];
  source,dest:byte;
  a:byte;
  c:char;
  w:word;
  p1,p2:^overlayer;
label anfang;
begin
  source:=1;
  dest:=1;
anfang:
  clrscr;
  writeln('LEVEL MANAGER');
  writeln;
  writeln('LEVELS      : ',campaign^.levelnum);
  writeln('SOURCE LEVEL: ',source);
  writeln('DESTINATION : ',dest);
  writeln;
  writeln('1) INSERT LEVEL AFTER SOURCE');
  writeln('2) DELETE SOURCE LEVEL ');
  writeln('3) COPY LEVEL FROM SOURCE TO DESTINATION');
  writeln('4) SWAP SOURCE AND DESTINATION');
  writeln('5) LOAD LEVEL FROM OTHER CAMPAIGN INTO SOURCE LEVEL');
  writeln('+/- INCREASE/DECREASE SOURCE LEVEL');
  writeln('>/< INCREASE/DECREASE DESTINATION LEVEL');
  writeln('ESC EXIT TO EDITOR MENU');
  c:=readkey;
  case c of
    '+': if source<campaign^.levelnum then inc(source);
    '-': if source>1 then dec(source);
    '>': if dest<=campaign^.levelnum then inc(dest);
    '<': if dest>1 then dec(dest);
    '1': begin
           if (campaign^.levelnum+1<=maxlevels) and (campaign^.levelnum<255) then
           begin
             inc(campaign^.levelnum);
             inc(source);
             for a:=campaign^.levelnum downto source+1 do
             movelevel(a-1,a);
             selectlevel(level,source);
             emptylevel;
           end else
           begin
             gotoxy(1,7);
             color(black,red);
             writeln('NOT ENOUGH MEMORY FOR ANOTHER LEVEL !');
             color(lightgray,black);
             delay(2000);
           end;
         end;
    '2': begin
           if confirm('DO YOU REALLY WANT TO DELETE LEVEL '+strx(source)) then
           begin
             if campaign^.levelnum=1 then
             begin
               selectlevel(level,1);
               emptylevel;
             end else
             begin
               dec(campaign^.levelnum);
               for a:=source to campaign^.levelnum do
               movelevel(a+1,a);
               if source>campaign^.levelnum then dec(source);
             end;
           end;
         end;
    '3': begin
           if dest>campaign^.levelnum then
           begin
             if (campaign^.levelnum+1<=maxlevels) and (campaign^.levelnum<255) then
             begin
               inc(campaign^.levelnum);
               movelevel(source,dest);
             end else
             begin
               gotoxy(1,9);
               color(black,red);
               writeln('NOT ENOUGH MEMORY FOR ANOTHER LEVEL !');
               color(lightgray,black);
               delay(2000);
             end;
           end else
           if confirm('DO YOU REALLY WANT TO OVERWRITE LEVEL '+strx(dest)) then
              movelevel(source,dest);
         end;
    '4': if dest<=campaign^.levelnum then
         begin
           selectlevel(pleveltype(p1),source);
           selectlevel(pleveltype(p2),dest);
           for w:=0 to campminsize-24-1 do
           begin
             a:=p1^[w];
             p1^[w]:=p2^[w];
             p2^[w]:=a;
           end;
         end;
    '5': begin
           oldname:=campname;
           campname:=choose('*.CPN',1);
           if campname<>'...' then
           begin
             campname:=campname+'.CPN';
             assign(campfile,campname);
             reset(campfile,1);
             st[0]:=#21;
             blockread(campfile,st[1],21);
             if st<>'NIBBLES CAMPAIGN FILE' then
             begin
               gotoxy(1,11);
               color(black,red);
               write('Not a NIBBLES CAMPAIGN FILE!');
               color(lightgray,black);
               delay(2000);
             end else
             begin
               gotoxy(1,24);
               write('Enter number of level to load: ');
               if readbyte(b,false) then
               begin
                 w:=(b-1)*(campminsize-24)+24;
                 seek(campfile,w);

                 selectlevel(level,source);
                 {$i-}
                 blockread(campfile,level^,campminsize-24);
                 {$i+}
                 if ioresult<>0 then
                 begin
                   gotoxy(1,24);
                   color(black,red);
                   write('Level does not exist in selected campaign!');
                   color(lightgray,black);
                   delay(2000);
                 end;
               end;
             end;
             close(campfile);
           end;
           campname:=oldname;
           assign(campfile,campname);
         end;


  end;
  if c<>#27 then goto anfang;
  selectlevel(level,1);
end;

procedure editmap;
var
  a,block:byte;
  c,temp:char;
  x,y:byte;
  drawflag:boolean;
  w:word;
procedure blockenv;
var b:byte;
begin
  if block<>0 then byte(playfield[0,10,1]):=black+red shl 4
              else byte(playfield[0,10,1]):=black+green shl 4;
  a:=0;
  b:=0;
  if block<10 then a:=255;
  repeat
    if byte(block+a-10)<>255 then
    begin
      byte(playfield[0,b,0]):=byte(block+a-10);
      inc(b);
    end;
    inc(a);
  until b=21;
end;

procedure draw;
begin
  with level^ do
  begin
    if ((x=startx1) and (y=starty1)) or ((x=startx2) and (y=starty2)) then exit;
    if block=0 then
    begin
      byte(playfield[y,x,1]):=red+green shl 4;
      w:=y-1;
      w:=w*80+x;
      allow[w div 8]:=allow[w div 8] and not (1 shl (w mod 8));
    end else
    if block=1 then
    begin
      w:=starty1-1;
      w:=w*80+startx1;
      playfield[starty1,startx1,0]:=' ';
      startx1:=x;
      starty1:=y;
      w:=starty1-1;
      w:=w*80+startx1;
      field[startx1,starty1-1]:=' ';
      playfield[starty1,startx1,0]:=#1;
    end else
    if block=2 then
    begin
      w:=starty2-1;
      w:=w*80+startx2;
      playfield[starty2,startx2,0]:=' ';
      startx2:=x;
      starty2:=y;
      w:=starty2-1;
      w:=w*80+startx2;
      field[startx2,starty2-1]:=' ';
      playfield[starty2,startx2,0]:=#2;
    end else
    begin
      byte(playfield[y,x,0]):=block;
      field[x,y-1]:=char(block);
      byte(playfield[y,x,1]):=lightgray;
      w:=y-1;
      w:=w*80+x;
      allow[w div 8]:=allow[w div 8] or (1 shl (w mod 8));
    end;
  end;
end;

begin
  clrscr;
  gotoxy(23,1);
  write('NO NUM:  P1 START:  P2 START:  USE SPACE,PGUP,PGDN,ARROWS');
  byte(playfield[0,29,1]):=green shl 4;
  playfield[0,40,0]:=#1;
  playfield[0,51,0]:=#2;
  with level^ do
  begin
    for y:=0 to 23 do
    for x:=0 to 79 do
    begin
      playfield[y+1,x,0]:=field[x,y];
      w:=y;
      w:=w*80+x;
      if (allow[w div 8] and (1 shl (w mod 8)))=0 then
         byte(playfield[y+1,x,1]):=red+green shl 4;
    end;

    playfield[starty1,startx1,0]:=#1;
    playfield[starty2,startx2,0]:=#2;
  end;
  block:=219;
  blockenv;
  setcursor(0,16);
  x:=0;
  y:=1;
  drawflag:=false;
  repeat
    gotoxy(x+1,y+1);
    temp:=playfield[y,x,0];
    if block<>0 then playfield[y,x,0]:=char(block)
                else
                begin
                  temp:=playfield[y,x,1];
                  byte(playfield[y,x,1]):=byte(playfield[y,x,1]) and 15 +green shl 4;
                end;
    c:=readkey;
    if block<>0 then playfield[y,x,0]:=temp
                else playfield[y,x,1]:=temp;
    if c=#0 then
    begin
      c:=readkey;
      case c of
        #72: begin
               dec(y);
               if y=0 then y:=24;
               if drawflag then draw;
             end;
        #80: begin
               inc(y);
               if y=25 then y:=1;
               if drawflag then draw;
             end;
        #75: begin
               dec(x);
               if x=255 then x:=79;
               if drawflag then draw;
             end;
        #77: begin
               inc(x);
               if x=80 then x:=0;
               if drawflag then draw;
             end;
        #73: begin
               dec(block);
               if block=255 then block:=254;
               blockenv;
               if drawflag then draw;
             end;
        #81: begin
               inc(block);
               if block=255 then block:=0;
               blockenv;
               if drawflag then draw;
             end;
      end;
    end else
    if c=' ' then
    begin
      drawflag:=drawflag xor true;
      if drawflag then draw;
    end;
  until c=#27;
end;

procedure editor;
var
  size:longint;
  choice:byte;
  a:word;
  x,y:byte;
  temp:pointer;
  result:word;
label anfang,menu;
begin
anfang:
  color(lightgray,black);
  clrscr;
  level:=ptr(seg(campaign^),ofs(campaign^)+24);
  current:=1;
  repeat
    campname:=choose('*.cpn',0);
  until campname<>'';
  clrscr;
  if campname='...' then exit;
  campname:=upcasestr(campname)+'.CPN';
  assign(campfile,campname);
  if exist(campname) then
  begin
    reset(campfile,1);
    size:=filesize(campfile);
    if size>camsize then
    begin
      close(campfile);
      writeln('Not enough memory to load this file !');
      delay(2000);
      goto anfang;
    end;
    temp:=campaign;
    for a:=1 to size div 32768 do
    begin
      blockread(campfile,temp^,32768);
      asm
        add word ptr temp+2,2048
      end;
    end;
    if size mod 32768<>0 then blockread(campfile,temp^,size mod 32768);
    close(campfile);
    
    move(campaign^.id,st[1],21);
    st[0]:=#21;
    if st<>'NIBBLES CAMPAIGN FILE' then
    begin
      writeln('Not a NIBBLES CAMPAIGN FILE !');
      delay(2000);
      goto anfang;
    end;
  end else
  begin
    {$i-}
    rewrite(campfile,1);
    {$i+}
    if ioresult<>0 then
    begin
      writeln('Cannot create file !');
      delay(2000);
      goto anfang;
    end;
    close(campfile);
    erase(campfile);
    makeemptycampaign;
  end;
menu:
  clrscr;
  gotoxy(40,1);
  write('BLACK=0         BLUE=1');
  gotoxy(40,2);
  write('GREEN=2         CYAN=3');
  gotoxy(40,3);
  write('RED=4           MAGENTA=5');
  gotoxy(40,4);
  write('BROWN=6         LIGHTGREY=7');
  gotoxy(40,5);
  write('GRAY=8          LIGHTBLUE=9');
  gotoxy(40,6);
  write('LIGHTGREEN=10   LIGHTCYAN=11');
  gotoxy(40,7);
  write('LIGHTRED=12     LIGHTMAGENTA=13');
  gotoxy(40,8);
  write('YELLOW=14       WHITE=15');
  gotoxy(40,10);
  write('UP=0            DOWN=1');
  gotoxy(40,11);
  write('LEFT=2          RIGHT=3');
  gotoxy(1,1);
  writeln(' 1) CAMPAIGN    : ',campname);
  writeln(' 2) P1 LIVES    : ',campaign^.lives1);
  writeln(' 3) P2 LIVES    : ',campaign^.lives2);
  writeln(' 4) LEVELS      : ',campaign^.levelnum);
  writeln(' 5) EDIT LEVEL  : ',current);
  writeln(' 6) TASK TYPE   : ',level^.task);
  writeln(' 7) TASK DESC.  : ',level^.numnum);
  writeln(' 8) P1 GROWTH   : ',level^.startgrowth1);
  writeln(' 9) P2 GROWTH   : ',level^.startgrowth2);
  writeln('10) P1 DIRECTION: ',level^.dir1);
  writeln('11) P2 DIRECTION: ',level^.dir2);
  writeln('12) P1 COLOR    : ',level^.p1color);
  writeln('13) P2 COLOR    : ',level^.p2color);
  writeln('14) FOREGROUND  : ',level^.forecolor);
  writeln('15) BACKGROUND  : ',level^.backcolor);
  writeln('16) DEATH COLOR : ',level^.deathcol);
  writeln('17) NUMBER COLOR: ',level^.numcolor);
  writeln('18) PLAYING FIELD');
  writeln('19) LOAD NEW CAMPAIGN');
  writeln('20) SAVE CAMPAIGN');
  writeln('21) CALL LEVEL MANAGER');
  writeln('22) QUIT EDITOR');
  writeln;
  write('Edit/Do what ? ');
  x:=wherex;
  y:=wherey;
  repeat
    choice:=18;
    gotoxy(x,y);
  until (readbyte(choice,true)=true) and (choice<23) and (choice<>0) and (choice<>4);
  gotoxy(1,y);
  write('':80);
  gotoxy(19,choice);
  case choice of
     1: begin
          st:=campname;
          if editstring(campname,12,true) then
          begin
            if pos('.',campname)<>0 then campname:=copy(campname,1,pos('.',campname)-1);
            delchars(campname,' ');
            campname:=upcasestr(campname)+'.CPN';
            if campname<>'.CPN' then
            begin
              if exist(campname) then
              if not confirm('CAMPAIGN ALREADY EXISTS! CHANGE NAME ANYWAY ?') then
                 campname:=st
              else
              else
              begin
                assign(campfile,campname);
                {$i-}
                rewrite(campfile,1);
                {$i+}
                if ioresult<>0 then
                begin
                  gotoxy(1,3);
                  color(black,red);
                  writeln('CANNOT CREATE FILE !');
                  color(lightgray,black);
                  delay(2000);
                  campname:=st;
                  assign(campfile,campname);
                  goto menu;
                end;
                close(campfile);
                erase(campfile);
              end;
            end else campname:=st;
          end;
        end;
     2: begin
          x:=campaign^.lives1;
          if not readbyte(campaign^.lives1,true) then campaign^.lives1:=x;
        end;
     3: begin
          x:=campaign^.lives2;
          if not readbyte(campaign^.lives2,true) then campaign^.lives2:=x;
        end;
     5: begin
          x:=current;
          if readbyte(current,true) then
          begin
            if current<=campaign^.levelnum then
               pointer(level):=splitaddr(address(campaign)+24+(current-1)*(campminsize-24))
            else
            begin
              if (campaign^.levelnum+1<=maxlevels) and (campaign^.levelnum<255) then
              begin
                current:=campaign^.levelnum+1;
                pointer(level):=splitaddr(address(campaign)+24+(current-1)*(campminsize-24));
                emptylevel;
                inc(campaign^.levelnum);
              end else
              begin
                gotoxy(1,7);
                color(black,red);
                writeln('NOT ENOUGH MEMORY FOR ANOTHER LEVEL !');
                color(lightgray,black);
                current:=x;
                delay(2000);
              end;
            end;
          end;
        end;
     6: begin
          x:=level^.task;
          if not readbyte(level^.task,true) or (level^.task>2) then level^.task:=x;
          if ((level^.task=1) or (level^.task=2)) and (x<>level^.task) then level^.numnum:=10;
        end;
      7: begin
          x:=level^.numnum;
          if not readbyte(level^.numnum,true) then level^.numnum:=x;
          if level^.numnum=0 then level^.numnum:=1;
         end;
      8: begin
          x:=level^.startgrowth1;
          if not readbyte(level^.startgrowth1,true) then level^.startgrowth1:=x;
         end;
      9: begin
          x:=level^.startgrowth2;
          if not readbyte(level^.startgrowth2,true) then level^.startgrowth2:=x;
         end;
     10: begin
          x:=level^.dir1;
          if not readbyte(level^.dir1,true) or (level^.dir1>3) then level^.dir1:=x;
         end;
     11: begin
          x:=level^.dir2;
          if not readbyte(level^.dir2,true) or (level^.dir2>3) then level^.dir2:=x;
         end;
     12: begin
          x:=level^.p1color;
          if not readbyte(level^.p1color,true) or (level^.p1color>15) {or
          (level^.p1color=level^.p2color) or (level^.p1color=level^.forecolor) }
          or (level^.p1color=level^.backcolor) {or (level^.p1color=level^.deathcol)} then level^.p1color:=x;
         end;
     13: begin
          x:=level^.p2color;
          if not readbyte(level^.p2color,true) or (level^.p2color>15) {or
          (level^.p2color=level^.p1color) or (level^.p2color=level^.forecolor)}
          or (level^.p2color=level^.backcolor){ or (level^.p2color=level^.deathcol)} then level^.p2color:=x;
         end;
     14: begin
          x:=level^.forecolor;
          if not readbyte(level^.forecolor,true) or (level^.forecolor>15) {or
          (level^.forecolor=level^.p1color) or (level^.forecolor=level^.p2color)}
          or (level^.forecolor=level^.backcolor) {or (level^.forecolor=level^.deathcol)} then level^.forecolor:=x;
         end;
     15: begin
          x:=level^.backcolor;
          if not readbyte(level^.backcolor,true) or (level^.backcolor>15) or
          (level^.backcolor=level^.p1color) or (level^.backcolor=level^.p2color)
          or (level^.backcolor=level^.forecolor) or (level^.backcolor=level^.numcolor) or (level^.backcolor=level^.deathcol)
             then level^.backcolor:=x;
         end;
     16: begin
          x:=level^.deathcol;
          if not readbyte(level^.deathcol,true) or (level^.deathcol>15){ or
          (level^.deathcol=level^.p1color) or (level^.deathcol=level^.p2color)
          or (level^.deathcol=level^.forecolor)} or (level^.deathcol=level^.backcolor) then level^.deathcol:=x;
         end;
     17: begin
          x:=level^.numcolor;
          if not readbyte(level^.numcolor,true) or (level^.numcolor>15) {or
          (level^.numcolor=level^.p1color) or (level^.numcolor=level^.p2color)}
          or (level^.numcolor=level^.backcolor) {or (level^.numcolor=level^.deathcol)} then level^.numcolor:=x;
         end;
     18: begin
           editmap;
           goto menu;
         end;
     19: if confirm('DO YOU REALLY WANT TO LOAD A NEW CAMPAIGN ?') then goto anfang;
     20: if confirm('SAVE THIS CAMPAIGN ?') then
         begin
           rewrite(campfile,1);
           temp:=campaign;
           size:=campaign^.levelnum*(campminsize-24)+24;
           for a:=1 to size div 32768 do
           begin
             blockwrite(campfile,temp^,32768,result);
             if result<32768 then
             begin
               saveerr;
               close(campfile);
               goto menu;
             end;
             asm
               add word ptr temp+2,2048
             end;
           end;
           if size mod 32768<>0 then blockwrite(campfile,temp^,size mod 32768,result);
           if result<>size mod 32768 then saveerr;
           close(campfile);
         end;
     21: levelmanager;
     22: if confirm('DO YOU REALLY WANT TO QUIT THE EDITOR ?') then exit;


  end; {case}
  goto menu;
end;

procedure titwrite(p:byte;c:char);
begin
  if p>181 then playfield[24-(p-182),0,0]:=c else
  if p>102 then playfield[24,182-p,0]:=c else
  if p>79  then playfield[p-79,79,0]:=c else
                playfield[0,p,0]:=c;
end;

procedure titleround(s:string;border:byte);
var
  a,b,c,d,e,f:byte;
begin
  if getticks-titletime<border then exit;
  titletime:=getticks;
  a:=1;
  inc(titlestart);
  if titlestart=206 then titlestart:=0;
  c:=titlestart;
  d:=206 mod length(s);
  e:=(206 div length(s)) div d;
  f:=0;
  for b:=1 to (206 div length(s))*length(s) do
  begin
    titwrite(c,s[a]);
    inc(c);
    if c=206 then c:=0;
    inc(a);
    if a>length(s) then
    begin
      a:=1;
      inc(f);
      if (f=e) and (d>0) then
      begin
        dec(d);
        titwrite(c,' ');
        inc(c);
        if c=206 then c:=0;
        f:=0;
      end;
    end;
  end;
end;

procedure endgame;
var
  a,b:byte;
  st:string[20];
begin
  playnote(0,0);
  for a:=0 to 24 do
  for b:=0 to 79 do
  byte(playfield[a,b,1]):=lightgray;
  color(yellow,blue);

  if play2 then
  begin
    gotoxy(1,10);
    if player[1].points>player[2].points then a:=1 else
    if player[2].points>player[1].points then a:=2 else a:=3;
    st:=' Player '+strx(a)+' wins ';
    if a=3 then st:='   Draw game   ';
    centerwriteln('ͻ',80);
    centerwriteln(st,80);
    centerwrite  ('ͼ',80);
    delay(1000);
  end;
  while keypressed do c:=readkey;
  if play2 then c:=readkey;
  restart:=true;
  if confirm('Do you want to play again ?') then restarttype:=2 else restarttype:=3;
end;


procedure newnum;
var
  a,b:byte;
  w,w2:word;
  count:word;
label warp;
begin
  count:=1;
  if incspeed and (slowie>50) and (numstoget mod 3=0) then dec(slowie);
  dec(numstoget);
  with level^ do
  begin
  if numstoget>0 then
  begin
    if task<>2 then
    begin
      if numstoget=1 then b:=0 else if task=0 then b:=11-numstoget else b:=random(7)+3;
      repeat
        inc(count);
        w:=random(240);
        a:=random(8);
        w2:=w*8+a;
        if count=500 then goto warp;
      until ((allow[w] and (1 shl a))<>0) and (playfield[(w2 div 80)+1,w2 mod 80,0]=' ');
      playfield[(w2 div 80)+1,w2 mod 80,0]:=char(b+$30);
      playfield[(w2 div 80)+1,w2 mod 80,1]:=char(level^.numcolor +level^.backcolor shl 4);
    end;
    if random(100)<=ptpercent then
    begin
      repeat
        w:=random(240);
        a:=random(8);
        w2:=w*8+a;
      until ((allow[w] and (1 shl a))<>0) and (playfield[(w2 div 80)+1,w2 mod 80,0]=' ');
      playfield[(w2 div 80)+1,w2 mod 80,0]:=char(158);
      playfield[(w2 div 80)+1,w2 mod 80,1]:=char(level^.numcolor +level^.backcolor shl 4);
    end;
    if random(100)<=lifepercent then
    begin
      repeat
        w:=random(240);
        a:=random(8);
        w2:=w*8+a;
      until ((allow[w] and (1 shl a))<>0) and (playfield[(w2 div 80)+1,w2 mod 80,0]=' ');
      playfield[(w2 div 80)+1,w2 mod 80,0]:=char(156);
      playfield[(w2 div 80)+1,w2 mod 80,1]:=char(level^.numcolor+level^.backcolor shl 4);
    end;
  end else
  begin
warp:
    inc(curlevel);
    if curlevel>campaign^.levelnum then
    begin
      player[1].lives:=0;
      player[2].lives:=0;
      notehead:=0;
      notetail:=0;
      play(victory1,12);
      play(victory2,30);
      vic:=true;
      notehead:=20;
      restart:=true;
    end else
    begin
      oldback:=level^.backcolor;
      oldfore:=level^.forecolor;
      reset(campfile,1);
      seek(campfile,24+(curlevel-1)*(campminsize-24));
      blockread(campfile,level^,campminsize-24);
      close(campfile);
      restart:=true;
      notehead:=0;
      notetail:=0;
      play(victory3,2);
      play(victory4,2);
      vic:=true;
      notehead:=20;
    end;
  end;
  end;
end;

procedure transbuf;
begin
  while keypressed do
  begin
    c:=upcase(readkey);
    if c in ['J','W','S','A','D','P',#27] then
    begin
      if ((head2=0) and (tail2<>20)) or ((head2>0) and (head2-tail2<>1)) then
      begin
        buffer2[tail2]:=c;
        inc(tail2);
        if tail2=21 then tail2:=0;
      end;
    end else
    if c=#0 then
    begin
      c:=readkey;
      if c in [#72,#75,#77,#80] then
      begin
        if ((head1=0) and (tail1<>20)) or ((head1>0) and (head1-tail1<>1)) then
        begin
          buffer1[tail1]:=c;
          inc(tail1);
          if tail1=21 then tail1:=0;
        end;
      end;
    end;
  end;
end;

function xkeypressed1:boolean;
begin
  xkeypressed1:=not (head1=tail1);
end;

function xkeypressed2:boolean;
begin
  xkeypressed2:=not (head2=tail2);
end;

function xreadkey1:char;
var
  temp:char;
begin
  temp:=buffer1[head1];
  inc(head1);
  if head1=21 then head1:=0;
  xreadkey1:=temp;
end;

function xreadkey2:char;
var
  temp:char;
begin
  temp:=buffer2[head2];
  inc(head2);
  if head2=21 then head2:=0;
  xreadkey2:=temp;
end;

function notethere:boolean;
begin
  notethere:=not (notehead=notetail);
end;

procedure nextnote;
begin
  inc(notehead);
  if notehead=21 then notehead:=0;
  if notethere then
  begin
    notecount:=notebuf[notehead].len;
    playnote(notebuf[notehead].value,notebuf[notehead].octave);
  end else notecount:=1;
end;

begin
  asm
    mov al,36h
    out 43h,al
    sub al,al
    out 40h,al
    out 40h,al
  end;
  randomize;
  oldexit:=exitproc;
  exitproc:=@haltx;
  camsize:=dosmemavail;
  camsize:=camsize*16;
  getdosmem(pointer(campaign),camsize);
  if (campaign=nil) or (camsize<campminsize) then
  begin
    writeln('NOT ENOUGH DOS MEMORY !');
    halt;
  end;
  if (camsize-24) div (campminsize-24)>=255 then maxlevels:=255 else
     maxlevels:=(camsize-24) div (campminsize-24);

  campname:='NONE';
  if exist('NIBBLES.CPN') then
  begin
    assign(campfile,'NIBBLES.CPN');
    reset(campfile,1);
    st[0]:=#21;
    blockread(campfile,st[1],21);
    if st='NIBBLES CAMPAIGN FILE' then campname:='NIBBLES.CPN';
    close(campfile);
  end;

  blinkbit(false);
  starttuneflag:=true;
anfang:
  
  setcursor(16,0);
  color(yellow,blue);
  clrscr;
  writeln;
  writeln;
  centerwriteln('NIBBLES EXTENDED',80);
  centerwriteln('Copyright (C) 1994 by Matthias Benkmann',80);
  centerwriteln('Created in Pascal. No knowledge from nibbles.bas used',80);
  writeln;
  centerwriteln('Guide your snake through the levels and eat the',80);
  centerwriteln('numbers to gain points and grow. Every 50000 points you',80);
  centerwriteln('will get an extra live. Pick up  to get extra points',80);
  centerwriteln('and  to get an extra life. Press <P> anywhere to',80);
  centerwriteln('pause and restart the game and ESC to abort the game.',80);
  writeln;
  centerwriteln('CURRENT CAMPAIGN: '+campname,80);
  writeln;
  centerwriteln('<L> Load Campaign',80);
  centerwriteln('<E> Call Editor  ',80);
  centerwriteln('<P> Play the Game',80);
  centerwriteln(' Player 2 Controls       <M> Switch Mode        Player 1 Controls  ',80);
  centerwriteln('       (UP)              <Q> Quit to DOS             (UP)          ',80);
  centerwriteln('        W                                                          ',80);
  centerwriteln('(LEFT) A D (RIGHT)                             (LEFT)     (RIGHT)  ',80);
  centerwriteln('        S                                                          ',80);
  centerwriteln('      (DOWN)                                        (DOWN)         ',80);

  playfield[19,61,0]:=#24;
  playfield[21,61,0]:=#25;
  playfield[20,60,0]:=#27;
  playfield[20,62,0]:=#26;

  titlestart:=0;
  titletime:=getticks-100;
  c:=#0;
  milicount:=0;
  notecount:=1;
  notehead:=0;
  notetail:=0;
  count21:=1;
  if starttuneflag then
  begin
    play(nibtheme3,18);
    play(nibtheme4,38);
    notehead:=20;
    starttuneflag:=false;
  end;
  repeat
    asm
@@wait:
      sub al,al
      out 43h,al
      in al,40h
      mov ah,al
      in al,40h
      xchg ah,al
      mov bx,milicount
      sub bx,ax
      jns @@weiter
      neg bx
@@weiter:
      cmp bx,2*1193
      jb @@wait
      mov milicount,ax
    end;
    dec(count21);
    if count21=0 then
    begin
      count21:=11;
      if notethere then dec(notecount);
      if notecount=0 then nextnote;
    end;
    titleround('NIBBLES EXTENDED ',1);
    if keypressed then
    begin
      ch:=upcase(readkey);
      if ch in ['E','Q','P','L','M'] then
      begin
        case ch of
        'E': begin
               playnote(0,0);
               notehead:=notetail;
               editor;
               campname:='NONE';
             end;
        'L': begin
               playnote(0,0);
               notehead:=notetail;
               color(lightgray,black);
               clrscr;
               campname:=choose('*.CPN',1);
               if campname='...' then campname:='NONE' else
               begin
                 campname:=campname+'.CPN';
                 assign(campfile,campname);
                 reset(campfile,1);
                 st[0]:=#21;
                 blockread(campfile,st[1],21);
                 close(campfile);
                 if not (st='NIBBLES CAMPAIGN FILE') then
                 begin
                   gotoxy(20,7);
                   color(black,red);
                   writeln('NOT A NIBBLES CAMPAIGN FILE !');
                   delay(2000);
                 end;
               end;
             end;
        'P': begin
               playnote(0,0);
               notehead:=notetail;
               if campname<>'NONE' then goto playstart;
               ch:='P';
             end;
        'Q': begin
               playnote(0,0);
               notehead:=notetail;
               halt;
             end;
        'M': begin
               playnote(0,0);
               notehead:=notetail;
               if vidmode=2 then vidmode:=1 else vidmode:=2;
               asm
                 mov al,vidmode
                 mov ah,12h
                 mov bl,30h
                 int 10h
                 mov ax,128+3
                 int 10h
               end;
               blinkbit(false);
             end;
        end;
        if ch<>'P' then goto anfang;
      end;
    end;
  until false;
playstart:
  clrscr;
  setcursor(6,7);
  writeln;
  write('How many players (1-2) ? ');
  repeat
    c:=upcase(readkey);
  until (c='1') or (c='2');
  if c='2' then play2:=true else play2:=false;
  writeln(c);
  enableesc:=false;
  write('Enter your skill level (0-90): ');
  x:=wherex;
  y:=wherey;
  repeat
    gotoxy(x,y);
    skill:=45;
    readbyte(skill,true);
  until skill<=90;
  enableesc:=true;
  if skill<75 then
  begin
    write('Increase game speed during play ? ');
    repeat
      c:=upcase(readkey);
    until (c='Y') or (c='N');
    if c='Y' then incspeed:=true else incspeed:=false;
    writeln(c);
  end else incspeed:=false;
  write('Enter your name, Player 1: ');
  enableesc:=false;
  editstring(player[1].name,11,false);
  if play2 then
  begin
    write('Enter your name, Player 2: ');
    editstring(player[2].name,11,false);
  end;
  enableesc:=true;
playstart3:
  setcursor(16,0);
  curlevel:=1;
  assign(campfile,campname);
  reset(campfile,1);
  blockread(campfile,campaign^,campminsize);
  close(campfile);
  pointer(level):=splitaddr(address(pointer(campaign))+24);
  slowie:=200-2*skill;
  player[1].lives:=campaign^.lives1;
  player[2].lives:=campaign^.lives2;
  if player[1].name='JOLLY ROGER' then player[1].lives:=99;
  if player[2].name='JOLLY ROGER' then player[2].lives:=99;
  player[1].points:=0;
  player[2].points:=0;
  if not play2 then player[2].lives:=0;
playstart2:
  restart:=false;
  if (player[1].lives=0) and (player[2].lives=0) then endgame;
  if restart then
  begin
    if restarttype=2 then goto playstart3;
    if restarttype=3 then goto anfang;
  end;
  startup;
  if player[1].lives=0 then player[1].state2:=dead;
  if player[2].lives=0 then player[2].state2:=dead;
  newnum;
  tail1:=0;
  head1:=0;
  tail2:=0;
  head2:=0;
  vic:=false;
  milicount:=0;
  slowiecount:=1;
  notecount:=1;
  notehead:=0;
  notetail:=0;
  count21:=1;
  play(nibtheme1,8);
  play(nibtheme2,16);
  notehead:=20;
  bonusflag:=0;
  while keypressed do c:=readkey;
  repeat
    asm
@@wait2:
      sub al,al
      out 43h,al
      in al,40h
      mov ah,al
      in al,40h
      xchg ah,al
      mov bx,milicount
      sub bx,ax
      jns @@weiter2
      neg bx
@@weiter2:
      cmp bx,2*1193
      jb @@wait2
      mov milicount,ax
    end;
    dec(count21);
    if count21=0 then
    begin
      count21:=11;
      if notethere then dec(notecount);
      if notecount=0 then nextnote;
    end;

    dec(slowiecount);
    if slowiecount=0 then
    begin
      slowiecount:=slowie;
      quitflag:=false;
      transbuf;
next1:
      if xkeypressed1 then
      begin
        c:=xreadkey1;
        case c of
          #72: begin
                 if player[1].direction=up then goto next1;
                 if player[1].direction<>down then player[1].direction:=up;
               end;
          #80: begin
                 if player[1].direction=down then goto next1;
                 if player[1].direction<>up then player[1].direction:=down;
               end;
          #75: begin
                 if player[1].direction=left then goto next1;
                 if player[1].direction<>right then player[1].direction:=left;
               end;
          #77: begin
                 if player[1].direction=right then goto next1;
                 if player[1].direction<>left then player[1].direction:=right;
               end;
        end;
      end;
  afterpause:
      if xkeypressed2 then
      begin
        c:=upcase(xreadkey2);
        case c of
          'W': begin
                 if player[2].direction=up then goto afterpause;
                 if player[2].direction<>down then player[2].direction:=up;
               end;
          'S': begin
                 if player[2].direction=down then goto afterpause;
                 if player[2].direction<>up then player[2].direction:=down;
               end;
          'A': begin
                 if player[2].direction=left then goto afterpause;
                 if player[2].direction<>right then player[2].direction:=left;
               end;
          'D': begin
                 if player[2].direction=right then goto afterpause;
                 if player[2].direction<>left then player[2].direction:=right;
               end;
          'P': begin
                 repeat
                   c:=upcase(readkey)
                 until c='P';
                 goto afterpause;
               end;
          'J': if (player[1].name='JOLLY ROGER') or (player[2].name='JOLLY ROGER') then
               begin
                 numstoget:=1;
                 newnum;
               end;
           #27: begin quitflag:=true; goto afterpause; end;
        end;
      end;
      if not (player[1].state2=dead) then player[1].state:=movesnake(player[1]);
      if play2 and not (player[2].state2=dead) then player[2].state:=movesnake(player[2]);
      if (player[1].state=dead) then death(player[1]);
      if (player[2].state=dead) then death(player[2]);

      if (player[1].state2=dead) and (player[2].state2=dead) then restart:=true;

      if player[1].state=number then grow(player[1]);
      if player[2].state=number then grow(player[2]);


      if restart and not notethere then goto playstart2;

      if not (player[1].state2=dead) then plot(player[1].tail[0].x,player[1].tail[0].y,player[1].tail[0].pos,player[1].col);
      if player[1].unplotflag then unplot(player[1].tail[player[1].len].x,player[1].tail[player[1].len].y
        ,player[1].tail[player[1].len].pos,player[1].col);
      if player[1].doubleunplotflag then
      begin
        if (player[1].unplotflag) or (player[1].fadecount=0) then
        begin
          dec(player[1].len);
          if player[1].len=0 then
          begin
            unplot(player[1].tail[player[1].len].x,player[1].tail[player[1].len].y
            ,player[1].tail[player[1].len].pos,level^.deathcol);
            player[1].doubleunplotflag:=false;
          end else
          unplot(player[1].tail[player[1].len].x,player[1].tail[player[1].len].y
          ,player[1].tail[player[1].len].pos,player[1].col);
        end;
        if not player[1].unplotflag then
        begin
          dec(player[1].fadecount);
          if player[1].fadecount=255 then player[1].fadecount:=deathfadestart;
        end;
      end;
      if play2 then
      begin
        if not (player[2].state2=dead) then plot(player[2].tail[0].x,player[2].tail[0].y,player[2].tail[0].pos,player[2].col);
        if player[2].unplotflag then unplot(player[2].tail[player[2].len].x,player[2].tail[player[2].len].y
          ,player[2].tail[player[2].len].pos,player[2].col);
        if player[2].doubleunplotflag then
        begin
          if (player[2].unplotflag) or (player[2].fadecount=0) then
          begin
            dec(player[2].len);
            if player[2].len=0 then
            begin
              unplot(player[2].tail[player[2].len].x,player[2].tail[player[2].len].y
              ,player[2].tail[player[2].len].pos,level^.deathcol);
              player[2].doubleunplotflag:=false;
            end else
            unplot(player[2].tail[player[2].len].x,player[2].tail[player[2].len].y
            ,player[2].tail[player[2].len].pos,player[2].col);
          end;
          if not player[2].unplotflag then
          begin
            dec(player[2].fadecount);
            if player[2].fadecount=255 then player[2].fadecount:=deathfadestart;
          end;
        end;
      end;
      if (player[1].state=number) or (player[2].state=number) then
      begin
        newnum;
        if not vic then
        begin
          notetail:=0;
          notehead:=0;
          play(numtune,8);
          notehead:=20;
        end;
      end;
      if bonusflag<>0 then
      begin
        notetail:=0;
        notehead:=0;
        if bonusflag=1 then play(bonus1,10) else play(bonus2,10);
        notehead:=20;
        bonusflag:=0;
      end;
      if quitflag then
      begin
        playnote(0,0);
        if confirm('Do you really want to abort the game ?') then goto anfang;
      end;
    end;
  until false;
end.